Subject: Re: regression in git-gui since 2c5c66b... Merge branch 'jp/get-ref-dir-unsorted

From: Mark Levedahl <[email-masked]>
Date: Mon, 17 Oct 2011 06:07:34 -0400

On 10/16/2011 11:40 PM, Michael Haggerty wrote:

> Please bear with me because I don't use git-gui so I don't really know
> what to expect.
>
> When I check out 2c5c66b and run the above script (actually, the script
> listed below) what I see in git-gui is:
>
> * In the "Unstaged Changes" window, "sub" is listed (not "sub/a").
>
> * When I click on "sub", then in the "Untracked, not staged" window,
> "Git Repository (subproject)" appears.
>
> I see the exact same thing when I run the same test script on the
> version before merge 2c5c66b.
>
> What do you see?
>
> What do you expect to see?
>
> What versions of git, exactly, are you testing (what version do you
> consider "good"; presumably it is version 2c5c66b that you consider "bad")?
>
> Are you certain that you are using the same git version for all commands
> ("git", "git-gui", and "git-new-workdir")?  Please especially note that
> git-new-workdir is not part of a default git install, and therefore it
> would be easy to accidentally use a different version of this script
> than of the other commands.
>
> Michael
>
> #!/bin/bash
>
> SRC=$(cd $(dirname $0); pwd)
> GIT=$SRC/git
> GIT_NEW_WORKDIR=$SRC/contrib/workdir/git-new-workdir
> GITGUI=$SRC/git-gui/git-gui
>
> rm -rf super sub
> mkdir super sub
> cd sub
> $GIT init
> touch a
> $GIT add a
> $GIT commit -m 'file' a
> $GIT pack-refs --all
> cd ../super
> $GIT init
> $GIT_NEW_WORKDIR ../sub sub
> $GITGUI&
Michael,

Thanks for looking....

Your modification of my script does not show the error for me, unless I 
have *installed* a version of git with the failure: I suspect git-gui 
invokes installed components, and not what is in the build directory, so 
having a good version of git installed with the bad version in the build 
directory does not show the error. And yes, I am quite sure that all of 
the git commands I am running are from the one version.

What I expect to see is what you saw: the "sub" directory listed under 
Unstaged Changes. What I get when I have installed version 2c5c66b (or 
current master) is the file "sub/a" listed under Unstaged Changes, in 
other words git-gui no longer recognizes that sub is a submodule.

Mark